(function(w, d){
	var locationMatch = function (patterns) {
		for (var key in patterns) {
			if (!(patterns[key].test(location[key]))) {
				return false;
			}
		}
		return true;
	};
	
	var isLoginIframe = locationMatch({
			hostname : /^dynamic.12306.cn$/,
			pathname : /^\/otsweb\/loginAction.do$/
		});
		
	var isQueryActionIframe = locationMatch({
			hostname : /^dynamic.12306.cn$/,
			pathname : /^\/otsweb\/order\/querySingleAction.do$/
		});
	
	var isConfirmPassengerActionIframe = locationMatch({
		hostname: /^dynamic.12306.cn$/,
		pathname: /^\/otsweb\/order\/confirmPassengerAction.do$/
	});
	
	var isOrderActionIframe = locationMatch({
		hostname: /^dynamic.12306.cn$/,
		pathname: /^\/otsweb\/order\/orderAction.do$/
	});
	
	var isPayConfirmOnlineSingleActionIframe = locationMatch({
	   hostname: /^dynamic.12306.cn$/,
	   pathname: /^\/otsweb\/order\/payConfirmOnlineSingleAction.do$/
	});
	
	if (isLoginIframe || isQueryActionIframe || isConfirmPassengerActionIframe || isOrderActionIframe || isPayConfirmOnlineSingleActionIframe) {
	}else{
		return;
	}	
	
	var each = function(sets, process){
		if (sets && sets.length && sets.length > 0) {
			for (var i = 0, len = sets.length; i < len; i++) {
				process && process(sets[i], i);
			}
		}
	};
	
	var page = (function(){
		var d = document,
		de = d.documentElement,
		db = d.body,
		compatMode = d.compatMode,
		isStrict = compatMode === 'CSS1Compat',
		page = isStrict ? de : db;
		
		var ua = navigator.userAgent.toLowerCase(),
		isOpera = /opera/.test(ua),
		isIE = !isOpera && /msie/.test(ua),
		isBorderBox = isIE && !isStrict;
		
		var scrollLeft = (function () {
			var override = typeof window.pageXOffset !== 'undefined' ?
			function () {
				return window.pageXOffset;
			}: function () {
				return de.scrollLeft || db.scrollLeft;
			};
			
			return {
				toString : override,
				valueOf : override
			};
		}());
		
		var scrollTop = (function () {
			var override = typeof window.pageYOffset !== 'undefined' ?
			function () {
				return window.pageYOffset;
			}: function () {
				return de.scrollTop || db.scrollTop;
			};
			
			return {
				toString : override,
				valueOf : override
			};
		}());
		
		var scrollWidth = (function () {
			var override = function () {
				return page.scrollWidth;
			};
			return {
				toString : override,
				valueOf : override
			};
		}());
		
		var scrollHeight = (function () {
			var override = function () {
				return page.scrollHeight;
			};
			return {
				toString : override,
				valueOf : override
			};
		}());

		var clientWidth = (function () {
			var override = function () {
				return page.clientWidth;
			};
			return {
				toString : override,
				valueOf : override
			};
		}());
		
		var clientHeight = (function () {
			var override = function () {
				return page.clientHeight;
			};
			return {
				toString : override,
				valueOf : override
			};
		}());
		
		return {
			scrollLeft : scrollLeft,
			scrollTop : scrollTop,
			scrollWidth : scrollWidth,
			scrollHeight : scrollHeight,
			clientWidth: clientWidth,
			clientHeight: clientHeight
		};
	}());
	
	var E = {
		on: (function(){
			if(document.addEventListener){
				return function(el, type, listener){
					el.addEventListener(type, listener, false);
				};
			}else if(document.attachEvent){
				return function(el, type, listener){
					el.attachEvent('on' + type, listener);
				};
			}else{
				return function(el, type, listener){
					el['on' + type] = listener;
				};
			}
		}())
	};
	
	var throttle = function(fn){
		var timer;
		return function(){
			if(timer){
				clearTimeout(timer);
			}
			timer = setTimeout(fn, 100);
		};
	};
	
	var Mask = (function(){
		var d = document,
			de = d.documentElement,
			db = d.body,
			
			mask,
			lock_flag = false,
			styleText = 'position: fixed;z-index: 10000000;display: none;left: 0;top: 0;width: 100%;background-color: rgba(102,102,102,0.5);filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=#80666666,endColorstr=#80666666);';
	
		return function () {
			var init = function () {
				mask = mask || (function(){
					var id = 'mask_' + (+ new Date);
					var mask = d.createElement('div');
					mask.id = id;
					mask.style.cssText = styleText;
					db.appendChild(mask);
					return mask;
				}());
				
				E.on(window, 'resize', throttle(function(){
					repaint();
				}));
				
				repaint();
			};
			
			var repaint = function () {
				var page_height = Math.max(page.clientHeight, page.scrollHeight);
				mask.style.height = page_height + 'px';
			};
			
			var lock = function () {
				lock_flag = true;
			};
			
			var unlock = function () {
				lock_flag = false;
			};
			
			var isLocked = function () {
				return lock_flag;
			};
			
			this.show = function () {
				if (isLocked()) {
					return false;
				}
				lock();
				
				de.style.overflow = 'hidden';
				db.style.overflow = 'hidden';
				
				mask.style.display = 'block';
			};
			
			this.hide = function () {
				if (!isLocked()) {
					return false;
				}
				unlock();
				
				de.style.overflow = '';
				db.style.overflow = '';
				
				mask.style.display = 'none';
			};
			
			init();
		};
	}());
	
	var Popup = function(args){
		var el, el_width, el_height, lock_flag = false;
		
		var init = function(args){
			el = args.el;
			
			el.style.display = 'block';
			el_width = el.offsetWidth;
			el_height = el.offsetHeight;
			
			el.style.display = 'none';
			el.style.position = 'fixed';
			el.style.zIndex = '10000001';
			
			E.on(window, 'resize', throttle(function(){
				repaint();
			}));
			
			repaint();
		};
		
		var lock = function () {
			lock_flag = true;
		};
		
		var unlock = function () {
			lock_flag = false;
		};
		
		var isLocked = function () {
			return lock_flag;
		};
		
		var repaint = function(){
			var page_width = +page.clientWidth,
				page_height = +page.clientHeight;
				
			el.style.left = (page_width - el_width) / 2 + 'px';
			el.style.top = (page_height - el_height) / 2 + 'px';
		};
		
		this.show = function(){
			if(isLocked()){
				return;
			}
			lock();
			repaint();
			el.style.display = 'block';
		};
		this.hide = function(){
			if (!isLocked()) {
				return false;
			}
			unlock();
			el.style.display = 'none';
		};
		
		init(args);
	};
	
	var Dialog = function(args){
		var mask = new Mask(),
			popup = new Popup({el: args.el});
		
		this.showMask = function(){
			mask.show();
		};
		
		this.show = function(){
			mask.show();
			popup.show();
		};
		
		this.hide = function(){
			popup.hide();
			mask.hide();
		};
	};
	
	var res = {
		path: sogouExplorer.extension.getURL('res')
	};
	
	res.imgs = {
		btnbg: {
			src: res.path + '/btn.png',
			width: 96,
			height: 31
		},
		cancelbtn: {
			src: res.path + '/cancel-btn.png',
			width: 58,
			height: 26
		},
		confirmbtn: {
			src: res.path + '/confirm-btn.png',
			width: 58,
			height: 26
		},
		change_kernel: {
			src: res.path + '/change-kernel.png',
			width: 68,
			height: 26
		},
		bg: {
			src: res.path + '/bg.png',
			width: 422,
			height: 227
		},
		toolbar: {
			src: res.path + '/toolbar.png',
			width: 920,
			height: 70
		},
		start_refresh_btn: {
			src: res.path + '/start-refresh-btn.png'
		},
		stop_refresh_btn: {
			src: res.path + '/stop-refresh-btn.png'
		},
		start_grab_btn: {
			src: res.path + '/start-grab-btn.png'
		},
		stop_grab_btn: {
			src: res.path + '/stop-grab-btn.png'
		}
	};
	
	var createDialog = function(){
		var tip_el = document.createElement('div');
		tip_el.style.cssText = "display: none; width: " + res.imgs.bg.width + "px;height: " + res.imgs.bg.height + "px;background-image: url(" + res.imgs.bg.src + ");line-height: " + res.imgs.bg.height + "px;text-align:center;}";
		
		var btns = document.createElement('div');
		btns.style.cssText = 'overflow: hidden;right: 17px;bottom: 15px;position: absolute;';
		tip_el.appendChild(btns);
		
		var cancelbtn = document.createElement('div');
		cancelbtn.style.cssText = 'float: right;display: none;background: url(' + res.imgs.cancelbtn.src + ') no-repeat;width: ' + res.imgs.cancelbtn.width + 'px;height: ' + res.imgs.cancelbtn.height + 'px;cursor: pointer;margin-left: 10' + 'px;';
		btns.appendChild(cancelbtn);
		
		var confirmbtn = document.createElement('div');
		confirmbtn.style.cssText = 'float: right;display: none;background: url(' + res.imgs.confirmbtn.src + ') no-repeat;width: ' + res.imgs.confirmbtn.width + 'px;height: ' + res.imgs.confirmbtn.height + 'px;cursor: pointer;margin-left: 10' + 'px;';
		btns.appendChild(confirmbtn);
		
		var text_el = document.createElement('div');
		text_el.style.cssText = 'display: inline-blcok;*display: inline;*zoom: 1;vertical-align: middle;text-align: center;color: rgb(123,123,123);font-size: 14px;';
		tip_el.appendChild(text_el);
		document.body.appendChild(tip_el);
		
		var tip_dialog = {};
		
		tip_dialog.cancelbtn = (function(cancelbtn){
			var handlers = {
				click: {
					internal: [],
					external: []
				}
			};
			
			var triggerHandlers = function(type, e){
				if(handlers[type]){
					each(handlers[type].internal, function(handler){
						handler.call(this, e);
					});
					each(handlers[type].external, function(handler){
						if(typeof handler === 'object'){
							handler.call(this, e);
						}else if(typeof handler === 'string'){ //handler indicates the name of the function
							if(typeof document.createEvent === 'function'){
								var event = document.createEvent('Event');
								event.initEvent(handler);
								document.dispatchEvent(event);
							}
						}
					});
				}
			};
			
			var addInternalHandler = function(type, handler){
				handlers[type] && handlers[type].internal && handlers[type].internal.push(handler);
			};
			
			var addExternalHandler = function(type, handler){
				handlers[type] && handlers[type].external && handlers[type].external.push(handler);
			};
			
			var removeExternalHandlers = function(type){
				handlers[type] && handlers[type].external && (handlers[type].external.length = 0);
			};
			
			var defaultSettings = function(){
				addInternalHandler('click', function(){
					tip_dialog.hide();
				});
			};
			
			var show = function(){
				cancelbtn.style.display = 'block';
			};
			
			var hide = function(){
				cancelbtn.style.display = 'none';
			};
			
			var setBackground = function(bgstr){
				if(bgstr){
					var img = res.imgs[bgstr];
					cancelbtn.style.width = img.width + 'px';
					cancelbtn.style.height = img.height + 'px';
					cancelbtn.style.background = 'url(' + img.src + ') no-repeat';
				}
			};
			
			cancelbtn.onclick = function(e){
				triggerHandlers('click', e);
			};
		
			defaultSettings();
			
			return {
				addExternalHandler: addExternalHandler,
				removeExternalHandlers: removeExternalHandlers,
				show: show,
				hide: hide,
				setBackground: setBackground
			};
		}(cancelbtn));
		
		tip_dialog.confirmbtn = (function(confirmbtn){
			var handlers = {
				click: {
					internal: [],
					external: []
				}
			};
			
			var triggerHandlers = function(type, e){
				if(handlers[type]){
					each(handlers[type].internal, function(handler){
						handler.call(this, e);
					});
					each(handlers[type].external, function(handler){
						handler.call(this, e);
					});
				}
			};
			
			var addInternalHandler = function(type, handler){
				handlers[type] && handlers[type].internal && handlers[type].internal.push(handler);
			};
			
			var addExternalHandler = function(type, handler){
				handlers[type] && handlers[type].external && handlers[type].external.push(handler);
			};
			
			var removeExternalHandlers = function(type){
				handlers[type] && handlers[type].external && (handlers[type].external.length = 0);
			};
			
			var defaultSettings = function(){
				addInternalHandler('click', function(){
					tip_dialog.hide();
				});
			};
			
			var show = function(){
				confirmbtn.style.display = 'block';
			};
			
			var hide = function(){
				confirmbtn.style.display = 'none';
			};
			
			var setBackground = function(bgstr){
				if(bgstr){
					var img = res.imgs[bgstr];
					confirmbtn.style.width = img.width + 'px';
					confirmbtn.style.height = img.height + 'px';
					confirmbtn.style.background = 'url(' + img.src + ') no-repeat';
				}
			};
			
			confirmbtn.onclick = function(e){
				triggerHandlers('click', e);
			};
		
			defaultSettings();
			
			return {
				addExternalHandler: addExternalHandler,
				removeExternalHandlers: removeExternalHandlers,
				show: show,
				hide: hide,
				setBackground: setBackground
			};
		}(confirmbtn));
		
		tip_dialog.setText = function(text){
			text_el.innerHTML = text;
		};
		
		setTimeout(function(){
			var dialog = new Dialog({el: tip_el});
			
			tip_dialog.setButtonType = function(args){
				var cancel_btn = args.CANCEL_BTN,
					confirm_btn = args.CONFIRM_BTN;
				
				tip_dialog.cancelbtn.hide();
				tip_dialog.confirmbtn.hide();
				
				if(cancel_btn){
					tip_dialog.cancelbtn.setBackground(cancel_btn.background);
					tip_dialog.cancelbtn.show();
				}
				if(confirm_btn){
					tip_dialog.confirmbtn.setBackground(confirm_btn.background);
					tip_dialog.confirmbtn.show();
				}
			};
			
			tip_dialog.show = function(args){
				dialog.show();
			};
			tip_dialog.hide = function(){
				dialog.hide();
			};
			tip_dialog.showMask = dialog.showMask;
		}, 100);
		
		return tip_dialog;
	};
	
	var tip_dialog = createDialog();
	
	var advice = function(callback){
		tip_dialog.confirmbtn.removeExternalHandlers('click');
		tip_dialog.confirmbtn.addExternalHandler('click', callback);
		tip_dialog.setText('<span>兼容模式下暂不支持12306助手功能，请您切换到高速模式</span>');
		tip_dialog.setButtonType({
			CANCEL_BTN: {
			},
			CONFIRM_BTN: {
				background: 'change_kernel'
			}
		});
		tip_dialog.show();
	};
	
	setTimeout(function(){
		var pattern = /MSIE (\d+)\.\d+/;
		var version = +navigator.appVersion.match(pattern)[1];
		
		var change2webkit = function(){
			sogouExplorer.extension.sendRequest({type: 'kernel', command: 'change2webkit'});
		};
		
		if(version < 7){
			alert('兼容模式下暂不支持12306助手功能，请您切换到高速模式');
			change2webkit();
		}else{
			advice(change2webkit);
		}
	}, 100);
}(window, document));