(function (window, document, undefined) {
	var locationMatch = function (patterns) {
		for (var key in patterns) {
			if (!(patterns[key].test(location[key]))) {
				return false;
			}
		}
		return true;
	};
	
	var isLoginIframe = locationMatch({
			hostname : /^dynamic.12306.cn$/,
			pathname : /^\/otsweb\/loginAction.do$/
		});
		
	var isQueryActionIframe = locationMatch({
			hostname : /^dynamic.12306.cn$/,
			pathname : /^\/otsweb\/order\/querySingleAction.do$/
		});
	
	var isConfirmPassengerActionIframe = locationMatch({
		hostname: /^dynamic.12306.cn$/,
		pathname: /^\/otsweb\/order\/confirmPassengerAction.do$/
	});
	
	var isOrderActionIframe = locationMatch({
		hostname: /^dynamic.12306.cn$/,
		pathname: /^\/otsweb\/order\/orderAction.do$/
	});
	
	var isPayConfirmOnlineSingleActionIframe = locationMatch({
	   hostname: /^dynamic.12306.cn$/,
	   pathname: /^\/otsweb\/order\/payConfirmOnlineSingleAction.do$/
	});
	
	if (isLoginIframe || isQueryActionIframe || isConfirmPassengerActionIframe || isOrderActionIframe || isPayConfirmOnlineSingleActionIframe) {
	}else{
		return;
	}
	
	var execInjectedScript = function(){
		var console = window.console || {
			log : window.alert
		};
		
		var each = function(items, callback){
			for(var i = 0, item; item = items[i]; i++){
				callback.call(item, item, i);
			}
		};

		var createStyle = (function () {
			var head,
			style,
			d = document;
			if (d.createStyleSheet) {
				return function (csstext) {
					style = d.createStyleSheet();
					style.styleText = csstext;
				};
			} else {
				return function (csstext) {
					style = document.createElement('style');
					style.textContent = csstext;
					head = head || document.head || document.getElementsByTagName('head')[0];
					head.appendChild(style);
				};
			}
		}
			());
		
		var page = (function(){
			var d = document,
			de = d.documentElement,
			db = d.body,
			compatMode = d.compatMode,
			isStrict = compatMode === 'CSS1Compat',
			page = isStrict ? de : db;
			
			var ua = navigator.userAgent.toLowerCase(),
			isOpera = /opera/.test(ua),
			isIE = !isOpera && /msie/.test(ua),
			isBorderBox = isIE && !isStrict;
			
			var scrollLeft = (function () { //console.log(page.scrollLeft)并不会得到数值，得到的是对象
				var override = typeof window.pageXOffset !== 'undefined' ?
				function () {
					return window.pageXOffset;
				}: function () {
					return de.scrollLeft || db.scrollLeft;
				};
				
				return {
					toString : override,
					valueOf : override
				};
			}());
			
			var scrollTop = (function () {
				var override = typeof window.pageYOffset !== 'undefined' ?
				function () {
					return window.pageYOffset;
				}: function () {
					return de.scrollTop || db.scrollTop;
				};
				
				return {
					toString : override,
					valueOf : override
				};
			}());
			
			var scrollWidth = (function () {
				var override = function () {
					return page.scrollWidth;
				};
				return {
					toString : override,
					valueOf : override
				};
			}());
			
			var scrollHeight = (function () {
				var override = function () {
					return page.scrollHeight;
				};
				return {
					toString : override,
					valueOf : override
				};
			}());

			var clientWidth = (function () {
				var override = function () {
					return page.clientWidth;
				};
				return {
					toString : override,
					valueOf : override
				};
			}());
			
			var clientHeight = (function () {
				var override = function () {
					return page.clientHeight;
				};
				return {
					toString : override,
					valueOf : override
				};
			}());
			
			return {
				scrollLeft : scrollLeft,
				scrollTop : scrollTop,
				scrollWidth : scrollWidth,
				scrollHeight : scrollHeight,
				clientWidth: clientWidth,
				clientHeight: clientHeight
			};
		}());
		
		var KEY = {
			ESC: 27,
			TAB: 9,
			ENTER: 13
		};
		
		var E = {
			on: (function(){
				if(document.addEventListener){
					return function(el, type, listener){
						el.addEventListener(type, listener, false);
					};
				}else if(document.attachEvent){
					return function(el, type, listener){
						el.attachEvent('on' + type, listener);
					};
				}else{
					return function(el, type, listener){
						el['on' + type] = listener;
					};
				}
			}()),
			un: (function(){
				if(document.removeEventListener){
					return function(el, type, listener){
						el.removeEventListener(type, listener, false);
					};
				}else if(document.attachEvent){
					return function(el, type, listener){
						el.detachEvent('on' + type, listener);
					};
				}else{
					return function(el, type){
						el['on' + type] = null;
					};
				}
			}()),
			preventDefault: function(e){
				if(e.preventDefault){
					e.preventDefault();
				}else{
					window.returnValue = false;
				}
			}
		};
		
		var throttle = function(fn){
			var timer;
			return function(){ //fn的一层包装，用来控制对fn的调用
				if(timer){
					clearTimeout(timer);
				}
				timer = setTimeout(fn, 100);
			};
		};
		
		var Mask = (function(){
			var d = document,
				de = d.documentElement,
				db = d.body,
				
				mask,
				lock_flag = false,
				styleText = 'position: fixed;z-index: 10000000;display: none;left: 0;top: 0;width: 100%;background-color: rgba(102,102,102,0.5);filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=#80666666,endColorstr=#80666666);',
				
				disableTabKey = function(e){
					if(e.keyCode === KEY.TAB){
						E.preventDefault(e);
					}
				};
				
			return function () {
				var init = function () {
					mask = mask || (function(){
						var id = 'mask_' + (+ new Date);
						var mask = d.createElement('div');
						mask.id = id;
						mask.style.cssText = styleText;
						db.appendChild(mask);
						return mask;
					}());
					
					E.on(window, 'resize', throttle(function(){
						repaint();
					}));
					
					repaint();
				};
				
				var repaint = function () {
					var page_height = Math.max(page.clientHeight, page.scrollHeight);
					mask.style.height = page_height + 'px';
				};
				
				var lock = function () {
					lock_flag = true;
				};
				
				var unlock = function () {
					lock_flag = false;
				};
				
				var isLocked = function () {
					return lock_flag;
				};
				
				this.show = function () {
					if (isLocked()) {
						return false;
					}
					lock();
					
					//disable the keyboard
					E.on(document, 'keydown', disableTabKey);
					
					de.style.overflow = 'hidden';
					db.style.overflow = 'hidden';
					
					mask.style.display = 'block';
				};
				
				this.hide = function () {
					if (!isLocked()) {
						return false;
					}
					unlock();
					
					//enable the keyboard
					E.un(document, 'keydown', disableTabKey);
					
					de.style.overflow = '';
					db.style.overflow = '';
					
					mask.style.display = 'none';
				};
				
				init();
			};
		}());
		
		var Popup = function(args){
			var el, el_width, el_height, lock_flag = false;
			
			var init = function(args){
				el = args.el;
				
				el.style.display = 'block';
				el_width = el.offsetWidth;
				el_height = el.offsetHeight;
				
				el.style.display = 'none';
				el.style.position = 'fixed';
				el.style.zIndex = '10000001';
				
				E.on(window, 'resize', throttle(function(){
					repaint();
				}));
				
				repaint();
			};
			
			var lock = function () {
				lock_flag = true;
			};
			
			var unlock = function () {
				lock_flag = false;
			};
			
			var isLocked = function () {
				return lock_flag;
			};
			
			var repaint = function(){
				var page_width = +page.clientWidth,
					page_height = +page.clientHeight;
					
				el.style.left = (page_width - el_width) / 2 + 'px';
				el.style.top = (page_height - el_height) / 2 + 'px';
			};
			
			this.show = function(){
				if(isLocked()){
					return;
				}
				lock();
				repaint();
				el.style.display = 'block';
			};
			this.hide = function(){
				if (!isLocked()) {
					return false;
				}
				unlock();
				el.style.display = 'none';
			};
			
			init(args);
		};
		
		var Dialog = function(args){
			var mask = new Mask(),
				popup = new Popup({el: args.el});
			
			this.showMask = function(){
				mask.show();
			};
			
			this.show = function(){
				mask.show();
				popup.show();
			};
			
			var hide = this.hide = function(){
				popup.hide();
				mask.hide();
			};
		};
		
		var res = {
			path: sogouExplorer.extension.getURL('res')
		};
		
		res.imgs = {
			btnbg: {
				src: res.path + '/btn.png',
				width: 96,
				height: 31
			},
			cancelbtn: {
				src: res.path + '/cancel-btn.png',
				width: 58,
				height: 26
			},
			confirmbtn: {
				src: res.path + '/confirm-btn.png',
				width: 58,
				height: 26
			},
			change_kernel: {
				src: res.path + '/change-kernel.png',
				width: 68,
				height: 26
			},
			bg: {
				src: res.path + '/bg.png',
				width: 422,
				height: 227
			},
			toolbar: {
				src: res.path + '/toolbar.png',
				width: 920,
				height: 70
			},
			start_refresh_btn: {
				src: res.path + '/start-refresh-btn.png'
			},
			stop_refresh_btn: {
				src: res.path + '/stop-refresh-btn.png'
			},
			start_grab_btn: {
				src: res.path + '/start-grab-btn.png'
			},
			stop_grab_btn: {
				src: res.path + '/stop-grab-btn.png'
			},
			start_submit_btn: {
				src: res.path + '/start-submit-btn.png',
				width: 102,
				height: 24
			},
			stop_submit_btn: {
				src: res.path + '/stop-submit-btn.png',
				width: 102,
				height: 24
			}
		};
		
		var createDialog = function(){
			var tip_el = document.createElement('div');
			tip_el.className = 'tip-dialog';
			
			var btns = document.createElement('div');
			btns.style.cssText = 'overflow: hidden;right: 17px;bottom: 15px;position: absolute;';
			tip_el.appendChild(btns);
			
			var cancelbtn = document.createElement('div');
			cancelbtn.style.cssText = 'float: right;display: none;background: url(' + res.imgs.cancelbtn.src + ') no-repeat;width: ' + res.imgs.cancelbtn.width + 'px;height: ' + res.imgs.cancelbtn.height + 'px;cursor: pointer;margin-left: 10' + 'px;';
			btns.appendChild(cancelbtn);
			
			var confirmbtn = document.createElement('div');
			confirmbtn.style.cssText = 'float: right;display: none;background: url(' + res.imgs.confirmbtn.src + ') no-repeat;width: ' + res.imgs.confirmbtn.width + 'px;height: ' + res.imgs.confirmbtn.height + 'px;cursor: pointer;margin-left: 10' + 'px;';
			btns.appendChild(confirmbtn);
			
			var text_el = document.createElement('div');
			text_el.style.cssText = 'display: inline-blcok;*display: inline;*zoom: 1;vertical-align: middle;text-align: center;color: rgb(123,123,123);font-size: 14px;';
			tip_el.appendChild(text_el);
			document.body.appendChild(tip_el);
			
			var tip_dialog = {};
			
			tip_dialog.cancelbtn = (function(cancelbtn){
				var handlers = {
					click: {
						internal: [],
						external: []
					}
				};
				
				var triggerHandlers = function(type, e){
					if(handlers[type]){
						each(handlers[type].internal, function(handler){
							handler.call(this, e);
						});
						each(handlers[type].external, function(handler){
							if(typeof handler === 'object'){
								handler.call(this, e);
							}else if(typeof handler === 'string'){ //handler indicates the name of the function
								if(typeof document.createEvent === 'function'){
									var event = document.createEvent('Event');
									event.initEvent(handler);
									document.dispatchEvent(event);
								}
							}
						});
					}
				};
				
				var addInternalHandler = function(type, handler){
					handlers[type] && handlers[type].internal && handlers[type].internal.push(handler);
				};
				
				var addExternalHandler = function(type, handler){
					handlers[type] && handlers[type].external && handlers[type].external.push(handler);
				};
				
				var removeExternalHandlers = function(type){
					handlers[type] && handlers[type].external && (handlers[type].external.length = 0);
				};
				
				var defaultSettings = function(){
					addInternalHandler('click', function(){
						tip_dialog.hide();
					});
				};
				
				var show = function(){
					cancelbtn.style.display = 'block';
				};
				
				var hide = function(){
					cancelbtn.style.display = 'none';
				};
				
				var setBackground = function(bgstr){
					if(bgstr){
						var img = res.imgs[bgstr];
						cancelbtn.style.width = img.width + 'px';
						cancelbtn.style.height = img.height + 'px';
						cancelbtn.style.background = 'url(' + img.src + ') no-repeat';
					}
				};
				
				cancelbtn.onclick = function(e){
					triggerHandlers('click', e);
				};
			
				defaultSettings();
				
				return {
					addExternalHandler: addExternalHandler,
					removeExternalHandlers: removeExternalHandlers,
					show: show,
					hide: hide,
					setBackground: setBackground
				};
			}(cancelbtn));
			
			tip_dialog.confirmbtn = (function(confirmbtn){
				var handlers = {
					click: {
						internal: [],
						external: []
					}
				};
				
				var triggerHandlers = function(type, e){
					if(handlers[type]){
						each(handlers[type].internal, function(handler){
							handler.call(this, e);
						});
						each(handlers[type].external, function(handler){
							handler.call(this, e);
						});
					}
				};
				
				var addInternalHandler = function(type, handler){
					handlers[type] && handlers[type].internal && handlers[type].internal.push(handler);
				};
				
				var addExternalHandler = function(type, handler){
					handlers[type] && handlers[type].external && handlers[type].external.push(handler);
				};
				
				var removeExternalHandlers = function(type){
					handlers[type] && handlers[type].external && (handlers[type].external.length = 0);
				};
				
				var defaultSettings = function(){
					addInternalHandler('click', function(){
						tip_dialog.hide();
					});
				};
				
				var show = function(){
					confirmbtn.style.display = 'block';
				};
				
				var hide = function(){
					confirmbtn.style.display = 'none';
				};
				
				var setBackground = function(bgstr){
					if(bgstr){
						var img = res.imgs[bgstr];
						confirmbtn.style.width = img.width + 'px';
						confirmbtn.style.height = img.height + 'px';
						confirmbtn.style.background = 'url(' + img.src + ') no-repeat';
					}
				};
				
				confirmbtn.onclick = function(e){
					triggerHandlers('click', e);
				};
			
				defaultSettings();
				
				return {
					addExternalHandler: addExternalHandler,
					removeExternalHandlers: removeExternalHandlers,
					show: show,
					hide: hide,
					setBackground: setBackground
				};
			}(confirmbtn));
			
			tip_dialog.setText = function(text){
				text_el.innerHTML = text;
			};
			
			setTimeout(function(){
				var dialog = new Dialog({el: tip_el});
				
				tip_dialog.setButtonType = function(args){
					/*
						CANCEL_BTN: {
							
						},
						CONFIRM_BTN: {
							background: 'change_kernel'
						}
					*/
					var cancel_btn = args.CANCEL_BTN,
						confirm_btn = args.CONFIRM_BTN;
					
					tip_dialog.cancelbtn.hide();
					tip_dialog.confirmbtn.hide();
					
					if(cancel_btn){
						tip_dialog.cancelbtn.setBackground(cancel_btn.background);
						tip_dialog.cancelbtn.show();
					}
					if(confirm_btn){
						tip_dialog.confirmbtn.setBackground(confirm_btn.background);
						tip_dialog.confirmbtn.show();
					}
				};
				
				tip_dialog.show = function(args){
					dialog.show();
				};
				tip_dialog.hide = function(){
					dialog.hide();
				};
				tip_dialog.showMask = dialog.showMask;
			}, 100);
			
			return tip_dialog;
		};
		
		var tip_dialog = createDialog();
		
		var loginUrl = "/otsweb/loginAction.do"; //登录页面地址
		var queryActionUrl = "/otsweb/order/querySingleAction.do"; //查询页面地址
		var confirmOrderUrl = "/otsweb/order/confirmPassengerAction.do";
		var orderActionUrl = '/otsweb/order/orderAction.do';
		var myOrderActionUrl = '/otsweb/order/myOrderAction.do';
		var payConfirmOnlineSingleActionUrl = '/otsweb/order/payConfirmOnlineSingleAction.do';
		
		function initUIDisplay() {
			injectStyle();
		}
		
		function injectStyle() {
			var csstext;
						
			csstext = "\
						#auto-login-btn{display: inline-block; width: " + res.imgs.btnbg.width + "px; height: " + res.imgs.btnbg.height + "px; background-image: url(" + res.imgs.btnbg.src + ");font-size: 12px;line-height: 31px;color: white;text-align: center;cursor: pointer;margin-left: 10px;}\
						.tip-dialog{display: none; width: " + res.imgs.bg.width + "px;height: " + res.imgs.bg.height + "px;background-image: url(" + res.imgs.bg.src + ");line-height: " + res.imgs.bg.height + "px;text-align:center;}\
						.check-ticket{margin-left: 10px;cursor: pointer;}\
						#ticket-toolbar{position: relative;font-size: 12px;margin: 0 auto;width: " + res.imgs.toolbar.width + "px;height: " + res.imgs.toolbar.height + "px;line-height: " + res.imgs.toolbar.height + "px;background-image: url(" + res.imgs.toolbar.src + ");}\
						.toolbar-mid{display: inline-block;_display: inline;_zoom: 1;vertical-align: middle;}\
						.lightblue-text{color: rgb(55,125,225);}\
						.blue-text{color: blue;}\
						#auto-refresh-text {margin-left: 10px;}\
						#auto-refresh-btn{width: 89px;height: 27px;margin-top: -2px;cursor: pointer;}\
						#auto-refresh-btn.stopped{background: url( " + res.imgs.start_refresh_btn.src + ") no-repeat;}\
						#auto-refresh-btn.running{background: url( " + res.imgs.stop_refresh_btn.src + ") no-repeat;}\
						#regular-refresh-text{margin-left: 40px;}\
						#choose-tickettime-text{}\
						#tickettime-options{width: 60px;}\
						#tickettime-link{margin-left: 5px;text-decoration: none;}\
						#choose-startdate-text{margin-left: 10px;}\
						#toolbar-startdate{width: 140px;}\
						#first-ticket-btn{margin-left: 2px;width: 94px;height: 27px;cursor: pointer;}\
						#first-ticket-btn.stopped{background: url( " + res.imgs.start_grab_btn.src + ") no-repeat;}\
						#first-ticket-btn.running{background: url( " + res.imgs.stop_grab_btn.src + ") no-repeat;}\
						#query-info{display: none;position: absolute;left: 70px;bottom: 5px;line-height: 100%;}\
						#first-ticket-info{display: none;position: absolute;left: 730px;bottom: 5px;line-height: 100%;}\
						";
			
			createStyle(csstext);
		}
		
		window.sogouExplorerExtension = window.sogouExplorerExtension || {};
		window.sogouExplorerExtension._12306 = {
			notify : function (msg, timeout) {
				sogouExplorer.extension.sendRequest({
					type : 'notification',
					command : 'notify',
					msg : msg,
					timeout : timeout || 5000
				});
			},
			closeNotify : function () {
				sogouExplorer.extension.sendRequest({
					type : 'notification',
					command : 'closeNotify'
				});
			},
			tip: {
				showMask: function(){
					tip_dialog.showMask();
				},
				hide: function(){
					tip_dialog.hide();
				},
				neterror: {
					popup: function(errorCount, callback){
						tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.cancelbtn.addExternalHandler('click', callback);
						tip_dialog.setText('<span>网络请求错误 ' + errorCount + ' 次，重试中</span>');
						tip_dialog.setButtonType({
							CANCEL_BTN: {}
						});
						tip_dialog.show();
					}
				},
				wait: {
					popup: function(count, callback){
						tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.cancelbtn.addExternalHandler('click', callback);
						tip_dialog.setText('<span>正在为您自动登录，已尝试登录 ' + count + ' 次</span>');
						tip_dialog.setButtonType({
							CANCEL_BTN: {}
						});
						tip_dialog.show();
					}
				},
				noUsername: {
					popup: function(){
						tip_dialog.setText('请输入用户名');
						tip_dialog.setButtonType({
							CANCEL_BTN: {},
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				username: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('请输入正确的用户名');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				noPwd: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('请输入密码，并且密码长度不小于6位');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				pwd: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('请输入正确的密码');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				noValidateCode: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('请输入4位验证码');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				validateCode: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('请输入正确的验证码');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				deny: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('您操作过于频繁，已被锁定');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				noFirstTicketTime: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('定时抢票功能需要您选择出票时间');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				noFirstTicketDate: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('定时抢票功能需要您选择出发日期');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				},
				disconnected: {
					popup: function(){
						//tip_dialog.cancelbtn.removeExternalHandlers('click');
						tip_dialog.setText('网络连接已断开，请检查您的网络环境');
						tip_dialog.setButtonType({
							CONFIRM_BTN: {}
						});
						tip_dialog.show();
					}
				}
			},
			getRemoteTime: function(){
				var port = sogouExplorer.extension.connect({name: 'remoteTime'});
				port.onMessage.addListener(function(msg){
					if(msg.command === 'ready'){
						triggerCustomEvent('sogouExplorerExtensionRemoteTimeReady', {
							remoteTime: msg.remoteTime
						});
					}
				});
				port.postMessage({command: 'get'});
			},
			getNetConnectionStatus: function(){
				var port = sogouExplorer.extension.connect({name: 'netConnection'});
				port.onMessage.addListener(function(msg){
					if(msg.command === 'informStatus'){
						triggerCustomEvent('sogouExplorerExtensionNetConnection.change', {
							status: msg.status
						});
					}else if(msg.command === 'unsupported'){
						triggerCustomEvent('sogouExplorerExtensionNetConnection.unsupported');
					}
				});
				port.postMessage({command: 'queryStatus'});
			},
			pingback: function(msg){
				sogouExplorer.extension.sendRequest({type: 'pingback', command: msg});
			},
			notification: {
				querySupport: function(){
					sogouExplorer.extension.sendRequest({
						type: 'notification',
						command: 'querySupport'
					}, function(isSupported){
						triggerCustomEvent('sogouExplorerExtensionNotification.querySupportOver', {
							support: isSupported
						});
					});
				}
			}
		};
	
		document.addEventListener('sogouExplorerExtensionNotify', function (e) {
			var message,
				timeout,
				detail = e.detail || {
					message: document.body.dataset['sogouExplorerExtensionNotify.message'],
					timeout: document.body.dataset['sogouExplorerExtensionNotify.timeout']
				};
			
			message = detail.message;
			timeout = detail.timeout;
			window.sogouExplorerExtension._12306.notify(message, timeout);
		}, false);
		document.addEventListener('sogouExplorerExtensionCloseNotify', function (e) {
			window.sogouExplorerExtension._12306.closeNotify();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.showMask', function(e){
			window.sogouExplorerExtension._12306.tip.showMask();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.hide', function(e){
			window.sogouExplorerExtension._12306.tip.hide();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.neterror', function(e){
			var errorCount,
				callback, 
				detail = e.detail || {
					errorCount: document.body.dataset['sogouExplorerExtensionTip.neterror.errorCount'],
					callback: document.body.dataset['sogouExplorerExtensionTip.neterror.callback']
				};
			
			errorCount = detail.errorCount;
			callback = detail.callback;
			window.sogouExplorerExtension._12306.tip.neterror.popup(errorCount, callback);
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.wait', function(e){
			var count,
				callback, 
				detail = e.detail || {
					count: document.body.dataset['sogouExplorerExtensionTip.wait.count'],
					callback: document.body.dataset['sogouExplorerExtensionTip.wait.callback']
				};
			
			count = detail.count;
			callback = detail.callback;
			window.sogouExplorerExtension._12306.tip.wait.popup(count, callback);
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.noUsername', function(e){
			window.sogouExplorerExtension._12306.tip.noUsername.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.username', function(e){
			window.sogouExplorerExtension._12306.tip.username.popup();
		}, false);	
		document.addEventListener('sogouExplorerExtensionTip.noPwd', function(e){
			window.sogouExplorerExtension._12306.tip.noPwd.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.pwd', function(e){
			window.sogouExplorerExtension._12306.tip.pwd.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.noValidateCode', function(e){
			window.sogouExplorerExtension._12306.tip.noValidateCode.popup();
		}, false);	
		document.addEventListener('sogouExplorerExtensionTip.validateCode', function(e){
			window.sogouExplorerExtension._12306.tip.validateCode.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.deny', function(e){
			window.sogouExplorerExtension._12306.tip.deny.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.disconnected', function(e){
			window.sogouExplorerExtension._12306.tip.disconnected.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionGetRemoteTime', function(e){
			window.sogouExplorerExtension._12306.getRemoteTime();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.noFirstTicketTime', function(e){
			window.sogouExplorerExtension._12306.tip.noFirstTicketTime.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionTip.noFirstTicketDate', function(e){
			window.sogouExplorerExtension._12306.tip.noFirstTicketDate.popup();
		}, false);
		document.addEventListener('sogouExplorerExtensionGetNetConnectionStatus', function(e){
			window.sogouExplorerExtension._12306.getNetConnectionStatus();
		}, false);
		
		document.addEventListener('sogouExplorerExtensionPingback.begin', function(e){
			window.sogouExplorerExtension._12306.pingback({type: 'begin'});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.startlogin', function(e){
			window.sogouExplorerExtension._12306.pingback({type: 'startlogin'});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.loginsuc', function(e){
			var autologin_count,
				detail = e.detail ||document.body.dataset['sogouExplorerExtensionPingback.loginsuc.count'];
			
			autologin_count = detail;
			window.sogouExplorerExtension._12306.pingback({type: 'loginsuc', count: autologin_count});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.startbuy', function(e){
			window.sogouExplorerExtension._12306.pingback({type: 'startbuy'});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.buysuc', function(e){
			var autorefresh_count,
				detail = e.detail ||document.body.dataset['sogouExplorerExtensionPingback.buysuc.count'];
			
			autorefresh_count = detail;
			window.sogouExplorerExtension._12306.pingback({type: 'buysuc', count: autorefresh_count});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.starttimer', function(e){
			window.sogouExplorerExtension._12306.pingback({type: 'starttimer'});
		}, false);
		document.addEventListener('sogouExplorerExtensionPingback.timersuc', function(e){
			window.sogouExplorerExtension._12306.pingback({type: 'timersuc'});
		}, false);
		
		document.addEventListener('sogouExplorerExtensionNotification.querySupport', function(e){
			window.sogouExplorerExtension._12306.notification.querySupport();
		}, false);
		
		var triggerCustomEvent = function(type, data){
			var event;
			if (typeof window.CustomEvent === 'function') {
				event = new window.CustomEvent(type, {
					detail: data ? data : {} 
				});
				document.dispatchEvent(event);
			}else if(typeof document.createEvent === 'function'){
				event = document.createEvent('Event');
				event.initEvent(type);
				
				if(data){
					for(var key in data){
						document.body.dataset[type + '.' + key] = data[key];
					}
				}
				document.dispatchEvent(event);
			}
		};
		
		var	pingback = {
			begin: function(){
				triggerCustomEvent('sogouExplorerExtensionPingback.begin');
			}
		};
	
		function beginExecute() {
			entryPoint();
		}
		
		var remote_res = {
			jspath: 'http://download.ie.sogou.com/se/12306'
		};
		
		var loadJS = function(src, success, failure){
			var script = document.createElement('script');
			script.src = src;
			script.onload = success;
			script.onerror = failure;
			(document.head ||document.getElementsByTagName('head')[0]).appendChild(script);
		};
		
		var loadRemote = function(callbackName, success, failure){
			var now = new Date,
				hour = now.getHours(),
				min = now.getMinutes();
			
			loadJS(remote_res.jspath + '/' + callbackName + '.js?h=' + hour + '&m=' + min, success, function(){
				failure(callbackName);
			});
		};
		
		var loadLocal = function(callbackName){
			loadJS(sogouExplorer.extension.getURL(callbackName + '.js'));
		};
		
		function load(callbackName){
			loadRemote(callbackName, undefined, loadLocal);
		}
	
		function entryPoint() {
			var location = window.location;
			var path = location.pathname;
			
			if (path == loginUrl) {
				load('initlogin'); //linux服务器区分大小写
			} else if (path == queryActionUrl) {
				load('initticketquery'); //linux服务器区分大小写
			} else if (path == confirmOrderUrl){
				load('initconfirmorder');
			}else if(path == orderActionUrl){
				load('initticketquery');
			}else if(path == payConfirmOnlineSingleActionUrl){
				load('initticketquery');
            }
		}
		
		pingback.begin();
		initUIDisplay();
		beginExecute();		
	};
	
	execInjectedScript();
}(window, document));